# 2022-05-10 Triage Log

A good week: Several performance improvements, many around macro expansion. Only
one regression of note, and that PR author opened an issue to follow up on it.

Triage done by **@pnkfelix**.
Revision range: [468492c2..c51871c4](https://perf.rust-lang.org/?start=468492c2af3993f18b1fe98052200575c4a2e678&end=c51871c469f7ed3b35ae25d7e6e77bc73fbdd0e3&absolute=false&stat=instructions%3Au)

**Summary**:

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 11                             | 37                               | 117                             | 65                                | 128                      |
| mean       | 0.7%                           | 0.7%                             | -1.2%                           | -1.6%                             | -1.1%                    |
| max        | 1.5%                           | 1.9%                             | -6.5%                           | -5.2%                             | -6.5%                    |


2 Regressions, 4 Improvements, 1 Mixed; 1 of them in rollups
59 artifact comparisons made in total

#### Regressions

Add a new Rust attribute to support embedding debugger visualizers [#91779](https://github.com/rust-lang/rust/pull/91779) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=322a14919d6cc67af45477b623857b30fae63f9d&end=a7d6768e3b60209d4195c822ea3247482909b604&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 88                             | 52                               | 0                               | 0                                 | 88                       |
| mean       | 0.4%                           | 0.5%                             | N/A                             | N/A                               | 0.4%                     |
| max        | 0.9%                           | 1.0%                             | N/A                             | N/A                               | 0.9%                     |

* Original PR author opened issue #96786 to investigate these regressions, and marked as triaged.
* (PR #96795 claims to resolve some of the regressions, but rust-timer didn't see any significant change from that.)

Rollup of 6 pull requests [#96877](https://github.com/rust-lang/rust/pull/96877) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=0e345b76a5550d82caff5540649ee0ba6e3b4f3f&end=0dd7e10282aaa7a3e1f5660f8bb043ee4ea07355&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 18                             | 0                                | 0                               | 0                                 | 18                       |
| mean       | 0.4%                           | N/A                              | N/A                             | N/A                               | 0.4%                     |
| max        | 0.7%                           | N/A                              | N/A                             | N/A                               | 0.7%                     |

* inspected graphs for the benchmarks at top of list of regressions: webrender-2022, regex-1.5.5, clap-3.1.6, cargo-0.60.0. It seems like any long-term effect here is quite minor, and
  the fact that *this* PR was tagged as significant is due to a blip in the measurements.
* marking as triaged.

#### Improvements

Speed up `Token::{ident,lifetime}` [#96683](https://github.com/rust-lang/rust/pull/96683) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=364bf39e3179e148742466810d0cb9c8ec1c343a&end=343889b7234bf786e2bc673029467052f22fca08&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 0                              | 0                                | 151                             | 82                                | 151                      |
| mean       | N/A                            | N/A                              | -0.9%                           | -0.7%                             | -0.9%                    |
| max        | N/A                            | N/A                              | -6.9%                           | -4.0%                             | -6.9%                    |


Overhaul `MacArgs` [#96546](https://github.com/rust-lang/rust/pull/96546) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=343889b7234bf786e2bc673029467052f22fca08&end=4c60a0ea5b2385d7400df9db1ad04e96f2a4c154&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 1                              | 1                                | 16                              | 9                                 | 17                       |
| mean       | 0.3%                           | 0.2%                             | -0.8%                           | -0.2%                             | -0.8%                    |
| max        | 0.3%                           | 0.2%                             | -1.4%                           | -0.3%                             | -1.4%                    |


Remove ItemLikeVisitor impls from rustc_typeck [#96531](https://github.com/rust-lang/rust/pull/96531) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4799baa70d0ff1780ee6dffb743d62c79235ace9&end=f6e5570460b2bb925021dc667ead2a9834ea88cb&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 0                              | 0                                | 9                               | 9                                 | 9                        |
| mean       | N/A                            | N/A                              | -0.3%                           | -0.4%                             | -0.3%                    |
| max        | N/A                            | N/A                              | -0.4%                           | -0.6%                             | -0.4%                    |


Optimize switch sources representation and usage [#96838](https://github.com/rust-lang/rust/pull/96838) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=88860d5474a32f507dde8fba8df35fd2064f11b9&end=cb390735b03aa44229ff2858be8fedbd7b0ce7cb&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 0                              | 0                                | 4                               | 7                                 | 4                        |
| mean       | N/A                            | N/A                              | -0.7%                           | -2.0%                             | -0.7%                    |
| max        | N/A                            | N/A                              | -1.0%                           | -2.6%                             | -1.0%                    |


#### Mixed

store `codegen_fn_attrs` in crate metadata [#96473](https://github.com/rust-lang/rust/pull/96473) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=0dd7e10282aaa7a3e1f5660f8bb043ee4ea07355&end=88860d5474a32f507dde8fba8df35fd2064f11b9&stat=instructions:u)

|            | Regressions 😿 <br />(primary) | Regressions 😿 <br />(secondary) | Improvements 🎉 <br />(primary) | Improvements 🎉 <br />(secondary) | All 😿 🎉 <br />(primary) |
|:----------:|:------------------------------:|:--------------------------------:|:-------------------------------:|:---------------------------------:|:------------------------:|
| count      | 6                              | 28                               | 89                              | 39                                | 95                       |
| mean       | 0.3%                           | 0.6%                             | -0.5%                           | -1.6%                             | -0.4%                    |
| max        | 0.6%                           | 2.2%                             | -1.4%                           | -4.8%                             | -1.4%                    |

* the regressions here were [anticipated](https://github.com/rust-lang/rust/pull/96473#issuecomment-1117448044) during development. The only regressions that arose were from [doc builds](https://github.com/rust-lang/rust/pull/96473#issuecomment-1121292857) (which I confirmed via inspection of the 6 regressing cases).
