# 2023-09-19 Triage Log

A pretty quiet week, with relatively few statistically significant changes, though some good improvements to a number of benchmarks, particularly in cycle counts rather than instructions.

Triage done by **@simulacrum**.
Revision range: [7e0261e7ea2085bdc0bc3d0fd6776bf343473858..af78bae565e85b9c5698ee909af0652674eca6d4](https://perf.rust-lang.org/?start=7e0261e7ea2085bdc0bc3d0fd6776bf343473858&end=af78bae565e85b9c5698ee909af0652674eca6d4&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.5%  | [0.3%, 0.8%]   | 14    |
| Regressions ❌ <br /> (secondary)  | 0.5%  | [0.2%, 0.8%]   | 5     |
| Improvements ✅ <br /> (primary)   | -1.2% | [-6.4%, -0.3%] | 22    |
| Improvements ✅ <br /> (secondary) | -2.1% | [-8.1%, -0.2%] | 37    |
| All ❌✅ (primary)                 | -0.5% | [-6.4%, 0.8%]  | 36    |

3 Regressions, 3 Improvements, 2 Mixed; 2 of them in rollups
56 artifact comparisons made in total

#### Regressions

Accept additional user-defined syntax classes in fenced code blocks [#110800](https://github.com/rust-lang/rust/pull/110800) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=42dead4d23309234802390aca16763f353920cf6&end=41bafc4ff3eb6a73aa40e60c3bd4494302c7ec57&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.7% | [0.5%, 0.9%] | 3     |
| Regressions ❌ <br /> (secondary)  | 0.9% | [0.5%, 1.4%] | 3     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.7% | [0.5%, 0.9%] | 3     |

Some slight regressions, limited to doc benchmarks, for a new feature in rustdoc.

Store a index per dep node kind [#115733](https://github.com/rust-lang/rust/pull/115733) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4514fb98d58eb0bcd65a16266875ef031c373cdf&end=341ef15eeed243dce9a30e800173450393bf776b&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4% | [0.2%, 0.5%] | 9     |
| Regressions ❌ <br /> (secondary)  | 0.3% | [0.2%, 0.5%] | 6     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.4% | [0.2%, 0.5%] | 9     |

Slight instruction regressions but overall an improvement -- max-rss and cycle
counts are both down in aggregate.

#### Improvements

Rollup of 6 pull requests [#115909](https://github.com/rust-lang/rust/pull/115909) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=8ed1d4a02ddd840a1efaca4e5e66881cbec5b0b3&end=db9c21fd944b942a3a83e1fbce0d7c1c9164bc2a&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.6% | [-1.0%, -0.5%] | 6     |
| Improvements ✅ <br /> (secondary) | -1.1% | [-1.5%, -0.4%] | 19    |
| All ❌✅ (primary)                 | -0.6% | [-1.0%, -0.5%] | 6     |


Rollup of 8 pull requests [#115929](https://github.com/rust-lang/rust/pull/115929) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=078eb1120a3f576598b976d9470701363f48fccc&end=de68911f4adaed19ac662880cf1a5ded9e44d685&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.2%  | [0.2%, 0.2%]   | 1     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.5% | [-0.7%, -0.2%] | 19    |
| Improvements ✅ <br /> (secondary) | -0.5% | [-0.6%, -0.2%] | 12    |
| All ❌✅ (primary)                 | -0.4% | [-0.7%, 0.2%]  | 20    |


move required_consts check to general post-mono-check function [#115748](https://github.com/rust-lang/rust/pull/115748) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=b1575cb72ef40459666f802af8636faf8428e3eb&end=cebb9cfd4f0052fbb5e98f9b6f3a61dae8fd96a7&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.5%  | [0.5%, 0.5%]   | 1     |
| Improvements ✅ <br /> (primary)   | -5.0% | [-6.3%, -3.6%] | 2     |
| Improvements ✅ <br /> (secondary) | -6.1% | [-6.6%, -5.7%] | 6     |
| All ❌✅ (primary)                 | -5.0% | [-6.3%, -3.6%] | 2     |

Cache reachable_set on disk [#115740](https://github.com/rust-lang/rust/pull/115740) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=790309b102a0f0459f0ca0ac0386cec2b8a9b0db&end=fd70f7eea23636d4ce83656f5c8c2b24cd56998c&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4%  | [0.4%, 0.4%]   | 1     |
| Regressions ❌ <br /> (secondary)  | 0.4%  | [0.4%, 0.6%]   | 4     |
| Improvements ✅ <br /> (primary)   | -1.0% | [-2.4%, -0.3%] | 8     |
| Improvements ✅ <br /> (secondary) | -2.6% | [-8.2%, -0.8%] | 4     |
| All ❌✅ (primary)                 | -0.9% | [-2.4%, 0.4%]  | 9     |

Regressions are actually just noise, so moved this to improvements.
